from tcpgecko import *
import struct

def make32Uint(addr_str):
	print(addr_str)
	return struct.unpack('>I', addr_str)[0]

def applyOneTime(codelist):
	for code in codelist:
		if not code.startswith('['):
			addr = int(code.split(' ')[0], 16)
			val = int(code.split(' ')[1], 16)
			rpc.pokemem(addr, val)
		else:
			pc = 0
			for c in code:
				if c == '[':
					pc +=1
			code = code.replace('[','').replace(']','')
			paddr = int(code.split(' ')[0], 16)
			val = int(code.split(' ')[1], 16)
			#loop through the pointers till we get to address
			while pc != 0:
				naddr = make32Uint(rpc.readmem(paddr, 4))
				pc -= 1
				paddr = naddr
			addr = naddr
			rpc.pokemem(addr, val)

def applyAlways(codelist):
	r_list = []
	for code in codelist:
		if not code.startswith('['):
			addr = int(code.split(' ')[0], 16)
			val = int(code.split(' ')[1], 16)
			r_list.append((addr,val))
		else:
			pc = 0
			for c in code:
				if c == '[':
					pc +=1
			code = code.replace('[','').replace(']','')
			paddr = int(code.split(' ')[0], 16)
			val = int(code.split(' ')[1], 16)
			#loop through the pointers till we get to address
			while pc != 0:
				naddr = makeAddr(rpc.readmem(paddr, 4))
				pc -= 1
				paddr = naddr
			addr = naddr
			r_list.append((addr,val))
	while True:
		for code in r_list:
			addr,const_val = code
			curr_val = make32Uint(rpc.readmem(addr,4))
			if curr_val != const_val:
				rpc.pokemem(addr,const_val)
			
if __name__ == '__main__':
	#Read Cheatfiles
	file = open('cheats.txt', 'r').readlines()
	refile = open('recheats.txt', 'r').readlines()

	codelist = []
	recodelist = []
	for line in file:
		if len(line) > 1:
			if not line.startswith("#"):
				codelist.append(line)
	for line in refile:
		if len(line) > 1:
			if not line.startswith("#"):
				recodelist.append(line)
				
	#Cheats loaded, setup RPC calls
	rpc = TCPGecko('10.0.0.19')
	applyOneTime(codelist)
	applyAlways(recodelist)
	
	